#####################################################
# Author        : Chester Rebeiro
# Institue      : IIT Madras
# Creation Time : Apr 7/ 2008
# Comment       :
# Top file for Itoh Tsujii code generator.
#####################################################
import os
import sys
import math

import quadblk
import control
import multiplier
import synthesis
import mux4
import mux2


i=0

# ac.txt contains the addition chain and irreducible polynomial
inp = open("ac.txt", "r")
while(1):
	line1 = inp.readline()   # Adder chain   
	if not line1:
		break;
	line2 = inp.readline()   # Finite Field 
	line3 = inp.readline()   # The trinomial
	line4 = inp.readline()   # Number of power blocks
	ac = line1.split()
	ffield = int(line2)
	trin = int(line3)
	npblks = int(line4)
	print ac
	print ffield, trin, npblks


	pwd = os.getcwd()
	#delete old project file if present
	os.system('rm -rf '+pwd+'/hdl/')
	os.mkdir(pwd+'/hdl')
	# Make mod.v
	os.system(pwd+'/modverilog '+str(ffield)+' '+str(trin))
	# Copy pow4.v
	#os.system('cp -f '+pwd+'/store/pow4.v '+pwd+'/hdl/')
	os.system(pwd+'/sqgen_verilog '+str(2)+' '+str(ffield)+' '+str(trin))
	# Make quadblk.v
	quadblk.make_hdl(ffield, npblks)
	# Make Karatsuba
	os.system(pwd+'/ks '+str(ffield)+' '+str(3))
	# Make multiplier.v
	multiplier.make_multiplier(ffield)
	# Make itoh.v
	control.make_hdl(ac, ffield, npblks)
	# Make mux4.v and mux2.v
	mux4.make(ffield);
	mux2.make(ffield);


	#And finally Synthesis
	#synthesis.callxst(ffield, pwd, i)

	i = i+1


