import os
import sys
import math

import fileheader

def make_multiplier(ffield):
	fp = open("hdl/multiplier.v", "w")
	
	fileheader.make(fp, "multiplier.v", "Finite Field Multiplier", "multiplier.py")
	
	fp.write("`ifndef __MUL_V__\n")
	fp.write("`define __MUL_V__\n")
	fp.write("`include \"ks"+str(ffield)+".v\"\n")
	fp.write("`include \"mod.v\"\n\n")

	fp.write("module multiplier(a, b, d);\n")
	fp.write("input wire ["+str(ffield-1)+":0] a;\n")
	fp.write("input wire ["+str(ffield-1)+":0] b;\n")
	fp.write("output wire ["+str(ffield-1)+":0] d;\n")

	fp.write("wire ["+str((ffield-1)*2)+":0] mout;\n\n")

	fp.write("ks"+str(ffield)+" ks(a, b, mout);\n")
	fp.write("mod   mod1(mout, d);\n\n")

	fp.write("endmodule\n")

	fp.write("`endif\n")

	fp.close()

	prj = open("hdl/itoh.prj", "a")
	prj.write("verilog work multiplier.v\n")
	prj.close()
