import os
import sys
import math

import fileheader

def make(ffield):
	fp = open("hdl/mux2.v", "w")
	
	fileheader.make(fp, "mux2.v", "2:1 input multiplexer", "mux2.py")
	
	fp.write("`ifndef __MUX2_V__\n")
	fp.write("`define __MUX2_V__\n")

	fp.write("module mux2(i0, i1, sel, out);\n\n")
	fp.write("input wire ["+str(ffield-1)+":0] i0, i1;\n")
	fp.write("input wire sel;\n")
	fp.write("output wire ["+str(ffield-1)+":0] out;\n\n")

	fp.write("assign out = (sel == 3'd0) ? i0 : i1;\n")

	fp.write("\nendmodule\n")

	fp.write("`endif\n")

	fp.close()

	prj = open("hdl/itoh.prj", "a")
	prj.write("verilog work mux2.v\n")
	prj.close()
