import os
import sys
import math

import fileheader

def make(ffield):
	fp = open("hdl/mux4.v", "w")
	
	fileheader.make(fp, "mux4.v", "4:1 input multiplexer", "mux4.py")
	
	fp.write("`ifndef __MUX4_V__\n")
	fp.write("`define __MUX4_V__\n")

	fp.write("module mux4(i0, i1, i2, i3, sel, out);\n\n")
	fp.write("input wire ["+str(ffield-1)+":0] i0, i1, i2, i3;\n")
	fp.write("input wire [1:0] sel;\n")
	fp.write("output wire ["+str(ffield-1)+":0] out;\n\n")

	fp.write("assign out = (sel == 3'd0) ? i0 \n")
	fp.write("\t\t : (sel == 3'd1) ? i1\n")
	fp.write("\t\t : (sel == 3'd2) ? i2\n")
	fp.write("\t\t : i3;\n")

	fp.write("\nendmodule\n")

	fp.write("`endif\n")

	fp.close()

	prj = open("hdl/itoh.prj", "a")
	prj.write("verilog work mux4.v\n")
	prj.close()

