import os
import math
import sys

import fileheader

def make_hdl(ff, len):
	selsize = int(math.ceil(math.log(len)/math.log(2))) 

	fp = open("hdl/quadblk.v", "w")
	fileheader.make(fp, "quadblk.v", "QuadBlock", "quadblk.py")
	fp.write("`ifndef __POW4BLK_V__\n")
	fp.write("`define __POW4BLK_V__\n")
	fp.write("`include \"pow4.v\"\n\n")
	
	fp.write("module pow4blk(a, sel, d);\n")
	fp.write("input ["+str(ff-1)+":0] a;\n")
	fp.write("input ["+str(selsize - 1)+":0] sel;\n")
	fp.write("output wire ["+str(ff-1)+":0] d;\n")

	for i in range(1, len+1):
		fp.write("wire ["+str(ff-1)+":0] d"+ str(i)+";\n") 
	fp.write("\n")
	fp.write("pow4 p4_1(a, d1);\n")
	for i in range(2, len+1):
		fp.write("pow4 p4_"+str(i)+"(d"+str(i-1)+", d"+str(i)+");\n")
	fp.write("\n")


	fp.write("assign d = (sel == "+str(selsize)+"'d1) ? d1\n")

	for i in range(2, len+1):
		fp.write("\t : (sel == "+str(selsize)+"'d"+str(i)+") ? d"+str(i)+"\n")

	fp.write("\t : d1;\n")
	fp.write("endmodule\n")
	fp.write("`endif\n")

	fp.close()
	
	prj = open("hdl/itoh.prj", "a")
	prj.write("verilog work quadblk.v\n")
	prj.close()
	
#make_hdl(233, 12) 
